
local _, GVF = ...

GVF.filters["Already Known Filter"] = {}
local filter = GVF.filters["Already Known Filter"]

do -- Tooltip Scanner to detect if we already know an item
	local Scanner = CreateFrame("GameTooltip", "GVF_AKF_ScannerTooltip", nil, "GameTooltipTemplate")
	Scanner:SetOwner(UIParent, "ANCHOR_NONE")
	local known_cache = {}
	setmetatable(known_cache, {__mode = "kv"})
	function filter:CheckIfKnown(link)
		if known_cache[link] then
			return true
		end
		Scanner:ClearLines()
		Scanner:SetHyperlink(link)
		for i=1,Scanner:NumLines() do
			Scanner[i] = Scanner[i] or _G["GVF_AKF_ScannerTooltipTextLeft"..i]
			if Scanner[i]:GetText() == ITEM_SPELL_KNOWN then
				known_cache[link] = true
				return true
			end
		end
		return false
	end
end

function filter:AddItem(link) end

function filter:ClearAll()
	self.alreadyknown = GVF.db.profile.alreadyknown
end

function filter:isFilterd(link)
	if not self.alreadyknown then
		return self:CheckIfKnown(link)
	end
end

function filter:ResetFilter()
	self.alreadyknown = GVF.db.profile.alreadyknown
end

function filter:ShowAll()
	self.alreadyknown = false
end

function filter:WriteDefault(db)
	db.profile.alreadyknown = false
end

local info, itemtypesorted, itemtypesortedL = {}, {}, {}
function filter:GetDropdown(level)
	wipe(info)
	wipe(itemtypesorted)
	info.keepShownOnClick = 1
    if level == 1 then
		info.text = ITEM_SPELL_KNOWN
		info.checked = self.alreadyknown
		info.func = function()
			self.alreadyknown = not self.alreadyknown
			ToggleDropDownMenu(1, nil, GVF.FilterMenu, GVF.FilterButton, 0, 0)
			ToggleDropDownMenu(1, nil, GVF.FilterMenu, GVF.FilterButton, 0, 0)
			GVF:UpdateMerchant()
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

GVF.filterOptions["Already Known Filter"] = {
	type = 'group',
	name = "Already Known Filter",
	args = {
		UIF = {
			name = "Already Known Filter Default",
			desc = 'When selected only unknown or not learnable items will be shown initially!',
			type = 'toggle',
			width = 'full',
			get = function(info)
				return GVF.db.profile.alreadyknown
			end,
			set = function(info, val)
				GVF.db.profile.alreadyknown = val
				filter:ResetFilter()
			end,
		},
	},
}
